<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_INC_CACHE")) return;
define("_INC_CACHE", "1");
include_ecrire('inc_serialbase.php3');

function squelette_obsolete($naissance, $vetuste)
{
  // vrif de la date de validit par rapport  la source
  // (ici le champ VETUSTE) et les fonctions agissant sur le compilateur
  // (celui-ci est suppos ne changer qu' l'installation)

  return (($GLOBALS['recalcul_squelettes'] == 'oui')
	  OR ((filemtime($vetuste) > $naissance)
	      or ((file_exists("ecrire/mes_options.php3")
		   AND (filemtime("ecrire/mes_options.php3") > $naissance)))
	      or ((file_exists("mes_fonctions.php3")
		  AND (filemtime("mes_fonctions.php3") > $naissance)))));
}

function page_obsolete($naissance, $vetuste)
{
  global $lastmodified; // pour l'entete HTTP homonyme
  // Inclusions multiples : derniere modification --- a verifier
  if ($lastmodified < $naissance) $lastmodified = $naissance;

  // vrif de la date de validit par rapport  la dure de vie

  return ((time() > ($naissance + $vetuste)) and (!timeout(false,false)));
}

function ramener_cache($cache, $obsolete, $table, $dodo=0)
{
  // attendre son tour
  while (!spip_get_lock($cache, 1)); 

  //cache dj compil ?
  $r = spip_fetch_array(spip_query("
SELECT texte,naissance,vetuste
FROM $table
WHERE hache = 0x$cache"));
  if (!$r)
    { 
#      spip_log("$cache absent");
      // Non. On annonce qu'on s'en occupe en le declarant d'age nul
      // On met aussi un texte standard pour que l'internaute sache quoi
      // faire en cas de pb (ne devrait pas arriver cependant)
      spip_query("
INSERT INTO $table (hache, naissance, texte)
VALUES (0x$cache, 0, 'Si votre navigateur affiche ce message, c\'est que $table est incomplte, suite  la disparition du processus " . getmypid() . ". Ressayez')");
    } else {
      // Oui, mais quel est son age ?
      $t = $r['naissance'];
      // age nul ==> un autre processus fait le boulot en ce moment.
      // Si ce perdant de PHP connaissait Waitpid, j'aurais pu synchroniser.
      // L je suis oblig de dormir 1 seconde systmatiquement
      // et d'estimer que s'il n'y a rien de neuf au rveil, 
      // c'est que le processus est mort et ne finira pas le boulot.
      // Avec un rendez-vous j'aurais meme pu augmenter la priorit du cache.
      if (!$t && !$dodo)
	{
	  spip_release_lock($cache);
	  sleep(1);
	  return ramener_cache($cache, $obsolete, $table, 1);
	}
      // test de vtust du cache ou de processus concurrent dcd
      if ($dodo || ($obsolete($t, $r['vetuste'])))
	{  // trop vieux ! ramener son age  0 cf ci-dessus
	  spip_query("
UPDATE	$table
SET	naissance=0, texte=" . getmypid() . "
WHERE	hache=0x$cache");
	  $r = '';
	} else 
	  {
	    $r = $r['texte'];
#	    spip_log("$obsolete prsent" . strlen($r));
	  }
    }
  spip_release_lock($cache);
  return $r;
}

function ramener_squelette($squelette)
{
  // L'valuation du squelette definit les fonctions associees aux boucles,
  // et fournit le nom de la fonction principale

  $c = md5($squelette);
  eval(ramener_cache($c, 'squelette_obsolete', 'spip_squelettes'));

  if (!$func_squelette_executer) {

    // Cache absent, effac ou erron ==> compilation
    // L'internaute s'impatientant, cacher en priorit basse, 

    include_local("inc-calcul-squel.php3");
    $timer_a = explode(" ", microtime());
    $r = calculer_squelette($squelette);
    $timer_b = explode(" ", microtime());
    $timer = ceil(1000*($timer_b[0] + $timer_b[1]-$timer_a[0]-$timer_a[1]));
    spip_log("Crer ($timer ms): $squelette " . strlen($r));
    // pour la mise au point
    if (file_exists("ecrire/data/.skeldif")) 
      {$f=fopen("ecrire/data/.skeldif", "a"); 
       fwrite($f,"\n############skeldif $c :$squelette\n");
       fwrite($f,$r);
       fclose($f);}
    spip_query("
UPDATE	LOW_PRIORITY spip_squelettes
SET	naissance=UNIX_TIMESTAMP(), 
	vetuste='" . $squelette . ".html',
	texte='" . addslashes($r) . "'
WHERE	hache=0x$c
");
    eval($r);
  }
  return $func_squelette_executer;
}

function ecrire_cache($appel, $cache, $page, $infosurpage, $delais) {
  if ($delais &&  empty($HTTP_POST_VARS))
    {
      // pour la mise au point
      if (file_exists("ecrire/data/.cachedif")) 
	{$f=fopen("ecrire/data/.cachedif", "a"); 
	fwrite($f,"\n############skeldif $cache :$appel\n");
	fwrite($f,$page);
	fclose($f);}
      // Comme pour les squelettes, cache diffr pour calmer l'impatience
#      spip_log("$cache cre $delais");
       spip_query("
UPDATE	LOW_PRIORITY spip_caches 
SET	naissance=UNIX_TIMESTAMP(),
	texte='" . addslashes($page) . "',
	vetuste= " . $delais . "
WHERE	hache=0x$cache
");
    }
  // pour l'instant on ne sait traiter que ces 2 infos-l:
    invalideur_de_cache(&$infosurpage, 'id_article', $cache);
    invalideur_de_cache(&$infosurpage, 'id_breve', $cache);
}

function invalideur_de_cache($a, $type, $cache) {
  if (is_array($a[$type]))
    {
      $values = '';
      foreach($a[$type] as $k => $v) { $values[] = "(0x$cache, $k)";}
      spip_query("
INSERT IGNORE INTO spip_" . $type . _SUFFIXE_DES_CACHES . "
(hache, " . $type . ")
VALUES " . join(", ", $values));
    }
}

//
// Recherche recursive du squelette
//

function chercher_squelette_hierarchie($fond, $id_rubrique, $dossier='') {
	if (!$id_rubrique) {
		if (@file_exists("$dossier$fond.html")) {
			return "$dossier$fond";
		} else if (@file_exists("$fond.html")) {
			return "$fond";
		} else if (@file_exists("$fond-dist.html")) {
			return "$fond-dist";
		} else {
			// erreur webmaster : $fond ne correspond a rien
			include_ecrire ("inc_presentation.php3");
			install_debut_html("Erreur sur le site");
			echo "<P>Aucun squelette <b>$dossier$fond</b> n'est disponible...</P>";
			install_fin_html();
			spip_log ("ERREUR: aucun squelette $dossier$fond n'est disponible...");
			exit;
		}
	}
	else {
		if (file_exists("$dossier$fond-$id_rubrique.html")) {
			return "$dossier$fond-$id_rubrique";
		} else {
			$query = "SELECT id_parent FROM spip_rubriques WHERE id_rubrique='$id_rubrique'";
			$result = spip_query($query);
			while($row = spip_fetch_array($result)) {
				$id_parent=$row['id_parent'];
			}
			return chercher_squelette_hierarchie($fond, $id_parent, $dossier);
		}
	}
}

function chercher_squelette($fond, $id_rubrique) {
	global $dossier_squelettes;

	// prendre en compte le bon repertoire (pas grave si on a deux / dans l'arborescence)
	$dossier = ($dossier_squelettes ? $dossier_squelettes.'/' : '');

	// On selectionne, dans l'ordre :
	// fond=10.html, fond-10.html, fond-<rubriques parentes>.html, fond.html puis fond-dist.html
	if (($id_rubrique > 0) AND (file_exists("$dossier$fond=$id_rubrique.html"))) {
		return "$dossier$fond=$id_rubrique";
	}
	else {
		return chercher_squelette_hierarchie($fond, $id_rubrique, $dossier); // recursif le long de la hierarchie
	}
}

function cherche_page($fond, $cache, $contexte, $rech='', $lang='', $id_r='') 
{
  static $fonctions_squelettes = '';

  include_local("inc-calcul.php3");

  $fond = chercher_squelette($fond, $id_r ? $id_r : $contexte['id_rubrique']);
  if ($lang)
    {
	lang_select($lang);
	if (@file_exists("$fond.$lang.html")) $fond = "$fond.$lang";
    }
  if (!$fonctions_squelettes[$fond])
    $fonctions_squelettes[$fond] =  ramener_squelette($fond);
  $timer_a = explode(" ", microtime());
  $page =  $fonctions_squelettes[$fond]($contexte, $cache);
  $timer_b = explode(" ", microtime());
  $timer = ceil(1000*($timer_b[0] + $timer_b[1] - $timer_a[0] - $timer_a[1]));
  $taille = ceil(strlen($page[0]) / 1024);
  spip_log("Crer: ($timer ms): $fond ($taille ko, cache: $cache)");
  if (!$rech)
    return $page;
  else {
    include_ecrire("inc_surligne.php3");
    spip_log("Recherche : $rech");
    return array(surligner_mots($page[0], $rech), $page[1]);
  } 
}

function calculer_page_globale($fond, $cache, $var_recherche) {
  global $contexte, $HTTP_GET_VARS;

	$contexte = '';
	$contexte_defaut = array('id_parent', 'id_rubrique', 'id_article', 'id_auteur',
		'id_breve', 'id_forum', 'id_secteur', 'id_syndic', 'id_syndic_article', 'id_mot', 'id_groupe', 'id_document');
	reset($contexte_defaut);
	while (list(, $val) = each($contexte_defaut)) {
		if ($HTTP_GET_VARS[$val]) {
			$contexte[$val] = intval($HTTP_GET_VARS[$val]);
		}
	}
	if ($GLOBALS['date'])
		$contexte['date'] = $contexte['date_redac'] = normaliser_date($GLOBALS['date']);
	else
		$contexte['date'] = $contexte['date_redac'] = date("Y-m-d H:i:s");

	$lang = lire_meta('langue_site');
	if ($contexte['lang'])
		$lang = $contexte['lang'];	// si inc-urls veut fixer la langue

	// Calcul de la rubrique associee a la requete
	// (selection de squelette specifique)

	if ($id = $contexte['id_rubrique']) {
		$id_rubrique_fond = $id;
		if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id'")))
			if ($row['lang']) $lang = $row['lang'];
	}
	else if ($id  = $contexte['id_breve']) {
		if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique FROM spip_breves WHERE id_breve='$id'"))) {
			$id_rubrique_fond = $row['id_rubrique'];
			if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id_rubrique_fond'")))
				if ($row['lang']) $lang = $row['lang'];
		}
	}
	else if ($id = $contexte['id_syndic']) {
		if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique FROM spip_syndic WHERE id_syndic='$id'"))) {
			$id_rubrique_fond = $row['id_rubrique'];
			if ($row = spip_fetch_array(spip_query("
SELECT lang FROM spip_rubriques WHERE id_rubrique='$id_rubrique_fond'")))
				if ($row['lang']) $lang = $row['lang'];
		}
	}
	else if ($id = $contexte['id_article']) {
		if ($row = spip_fetch_array(spip_query("
SELECT id_rubrique,lang FROM spip_articles WHERE id_article='$id'"))) {
			$id_rubrique_fond = $row['id_rubrique'];
			if ($row['lang']) $lang = $row['lang'];
		}
	}
	else {
		$id_rubrique_fond = 0;
	}

	// Special stats et boutons admin
	reset($contexte_defaut);
	$signale_globals = "";
	while (list($key, $val) = each($contexte_defaut)) {
		if ($contexte[$val]) {
			$GLOBALS[$val] = $contexte[$val];
			$signale_globals .= '$GLOBALS[\''.$val.'\'] = '.intval($contexte[$val]).";";
		}
	}
	$page = cherche_page($fond, $cache, $contexte, $var_recherche, $lang, $id_rubrique_fond);
	return (!$signale_globals ? $page :
		array('<'."?php $signale_globals ?".'>'.$page[0], $page[1]));
}

// Regarde dans une table de nom de caches ceux vrifiant une condition donne
// Les retire de cette table et de la table gnrale des caches

function update_cache($cond, $table)
{
  global $spip_tables_principales;
  $result = spip_query("
SELECT  DISTINCT hache 
FROM    $table" . (!$cond ? '' : "
WHERE   $cond
"));
  $tous = '';
  while ($row = spip_fetch_array($result)) $tous[] = $row['hache'];
  if ($tous) {
    $tous = join(', ', $tous);
#    spip_log("$tous dtruits");
      spip_query("
DELETE FROM spip_caches
WHERE hache IN ($tous)
");
      foreach($spip_tables_principales as $a)
	{
	  spip_query("
DELETE FROM spip_" . $GLOBALS[$a . '_key']["PRIMARY KEY"] . _SUFFIXE_DES_CACHES ."
WHERE hache IN ($tous)
");
	}
  }
}
?>
