<?php
//////////////////////////////////////////////////////////////////////////////
//
//              Parsing des squelettes
//
//////////////////////////////////////////////////////////////////////////////


class Texte {
	var $type = 'texte';
	var $texte;
}

class Inclure {
	var $type = 'include';
	var $fichier;
	var $params;
}

class Champ {
	var $type = 'champ';
	var $nom_champ, $id_champ;
	var $cond_avant, $cond_apres; // tableaux d'objets
	var $fonctions;
}

function parser_texte($texte) {
  while (ereg("<INCLU[DR]E[[:space:]]*\(([-_0-9a-zA-Z./ ]+)\)([^>]*)>", $texte, $match)) {
    $s = $match[0];
    $p = strpos($texte, $s);
    $debut = substr($texte, 0, $p);
    $texte = substr($texte, $p + strlen($s));
    if ($debut)
      {
	$champ = new Texte;
	$champ->texte = $debut;
	$result[] = $champ;
      }
    $champ = new Inclure;
    $champ->fichier = $match[1];
    $p = trim($match[2]);
    if (!$p)
      $champ->params = '';
    else {
      if (!(ereg('^\\{(.*)\\}$', $p, $params)))
	{
	  include_ecrire ("inc_presentation.php3");
	  install_debut_html("Paramtres incorrects");
	  echo ' ( <FONT color="#FF000"> ' . 
	    entites_html($p) .
	    '</FONT> )<br> dans l\'inclusion de <FONT color="#FF000">' .
	    entites_html($champ->fichier) .
	    '</FONT>.'; 
	  install_fin_html();
	  exit;
	}
      else $champ->params = split("\}[[:space:]]*\{", $params[1]);
    }
    $result[] = $champ;
  }
  if ($texte)
    {
	$champ = new Texte;
	$champ->texte = $texte;
	$result[] = $champ;
    }

  return $result;
}


function parser_champs($texte) {
	global $champs;
	global $champs_count;
	global $champs_valides;
	global $champs_traitement;
	global $champs_pretraitement;
	global $champs_posttraitement;

	$debut = '';
	$result=Array();
	while ($texte) {
		$r = ereg('(#([a-zA-Z_]+)(\*?))', $texte, $regs);
		if ($r) {
			unset($champ);
			$nom_champ = $regs[2];
			$flag_brut = $regs[3];
			$s = $regs[1];
			$p = strpos($texte, $s);
			if ($champs_valides[$nom_champ]) {
				$debut .= substr($texte, 0, $p);
				if ($debut) 
				  $result = array_merge($result,parser_texte($debut));
				$champ = new Champ;
				$champ->nom_champ = $nom_champ;
				$champ->fonctions = $champs_pretraitement[$nom_champ];
				if (!$flag_brut AND $champs_traitement[$nom_champ]) {
					reset($champs_traitement[$nom_champ]);
					while (list(, $f) = each($champs_traitement[$nom_champ])) {
						$champ->fonctions[] = $f;
					}
				}
				if ($champs_posttraitement[$nom_champ]) {
					reset($champs_posttraitement[$nom_champ]);
					while (list(, $f) = each($champs_posttraitement[$nom_champ])) {
						$champ->fonctions[] = $f;
					}
				}
				$champs_count++;
				$champ->id_champ = $champs_count;
				$champs[$champs_count] = $champ;
				$result[] = $champ;
				$debut = '';
			}
			else {
				$debut .= substr($texte, 0, $p + strlen($s));
			}
			$texte = substr($texte, $p + strlen($s));
		}
		else {
			$debut .= $texte;
			if ($debut) 
			  $result = array_merge($result, parser_texte($debut));
			break;
		}
	}
	return $result;
}


function parser_champs_etendus($texte) {
	global $champs;
	global $champs_count;
	global $champs_valides;
	global $champs_traitement;
	global $champs_pretraitement;
	global $champs_posttraitement;

	$debut = '';
	while ($texte) {
		$r = ereg('(\[([^\[]*)\(#([a-zA-Z_]+)(\*?)([^])]*)\)([^]]*)\])', $texte, $regs);

		if (!$r)
		  return array_merge($result, parser_champs($debut.$texte));
		else {
			$cond_avant = $regs[2];
			$nom_champ = $regs[3];
			$flag_brut = $regs[4];
			$fonctions = $regs[5];
			$cond_apres = $regs[6];
			$s = $regs[1];
			$p = strpos($texte, $s);
			if ($champs_valides[$nom_champ]) {
				$debut .= substr($texte, 0, $p);
				if ($debut) {
					$c = parser_champs($debut);
					reset($c);
					while (list(, $val) = each($c)) $result[] = $val;
				}
				$champ = new Champ;
				$champ->nom_champ = $nom_champ;
				$champ->cond_avant = parser_champs($cond_avant);
				$champ->cond_apres = parser_champs($cond_apres);
				$champ->fonctions = $champs_pretraitement[$nom_champ];
				if (!$flag_brut AND $champs_traitement[$nom_champ]) {
					reset($champs_traitement[$nom_champ]);
					while (list(, $f) = each($champs_traitement[$nom_champ])) {
						$champ->fonctions[] = $f;
					}
				}
				if ($fonctions) {
					$fonctions = explode('|', ereg_replace("^\|", "", $fonctions));
					reset($fonctions);
					while (list(, $f) = each($fonctions)) $champ->fonctions[] = $f;
				}
				if ($champs_posttraitement[$nom_champ]) {
					reset($champs_posttraitement[$nom_champ]);
					while (list(, $f) = each($champs_posttraitement[$nom_champ])) {
						$champ->fonctions[] = $f;
					}
				}
				$champs_count++;
				$champ->id_champ = $champs_count;
				$champs[$champs_count] = $champ;
				$result[] = $champ;
				$debut = '';
			}
			else {
				$debut .= substr($texte, 0, $p + strlen($s));
			}
			$texte = substr($texte, $p + strlen($s));
		}
	}
	return $result;
}

function parser_param($params, $result, $idb) {
      $params2 = Array();
      $i = 1;
      while (ereg('^[[:space:]]*\{[[:space:]]*([^ \}])([^\"\}]*)([\"\}])(.*)$', $params, $args)) {
	if ($args[3] == "}")
	  {
	    $params = $args[4];
	    ereg("^(.*[^ \t\n])[[:space:]]*$", $args[2], $m);
	    $param = $args[1] . $m[1];
	    if ($param == 'tout') {
	      $result->tout = true;
	    }
	    else if ($param == 'plat') {
	      $result->plat = true;
	    }
	    else $params2[] = $param;
	  }
	else
	  { 
	    if ($args[1] == '"')
	      {
		if (!ereg("[[:space:]]*\}(.*)$", $params, $m))
		  break;
		else
		  {
		    $params = $m[1];
		    $result->separateur = 
		      ereg_replace("'","\'",$args[2]);
		  }
	      }
	    else
	      {
		if (!ereg("([^\"]*\"[[:space:]]*)\}(.*)$", $args[4], $m))
		  break;
		else
		  {
		    $params = $m[2];
		    $params2[] = $args[1] . $args[2] . '"' . $m[1];
		  }
	      }
	  }
	$i++;
      }
      if ($params)
	{
	  include_ecrire ("inc_presentation.php3");
	  install_debut_html("Paramtre incorrect");
	  echo "<p>$i" . '<sup>e</sup> paramtre et suivants (<FONT color="#FF000"> ' . 
	    entites_html($params) .
	    '</FONT> ) dans la boucle <FONT color="#FF000">' .
	    entites_html($idb) .
	    '</FONT>.'; 
	  install_fin_html();
	  exit;
	}
      $result->param = $params2;
}

function parser_boucle($texte, $id_parent) {

	// Detecter la boucle

	$p = strpos($texte, '<BOUCLE');
	if (!$p && (substr($texte, 0, strlen('<BOUCLE')) != '<BOUCLE')) {
	  return false;
	}

	$result = new Boucle;
	$result->id_parent = $id_parent;

	$debut = substr($texte, 0, $p);
	$milieu = substr($texte, $p);

	if (!ereg("^<BOUCLE([0-9]+|[-_][-_.a-zA-Z0-9]*)[[:space:]]*\(([^)]*)\)[[:space:]]*(([[:space:]]*\{[^}]*\})*)[[:space:]]*>", $milieu, $match)) {
		include_ecrire ("inc_presentation.php3");
		install_debut_html("Boucle incorrecte");
		echo '<p>La boucle ' . entites_html($milieu) . ' est incorrecte.';
		install_fin_html();
		exit;
	}

	$commande = $match[0];
	$id_boucle = $match[1];
	$nom = $match[2];
	$params = $match[3];

	// Decomposer les structures conditionnelles

	$s = "<B$id_boucle>";

	$p = strpos($debut, $s);
	if ($p || (substr($debut, 0, strlen($s)) == $s)) {
		$cond_avant = substr($debut, $p + strlen($s));
		$debut = substr($debut, 0, $p);
	}

	$milieu = substr($milieu, strlen($commande));
	$s = "</BOUCLE$id_boucle>";
	$p = strpos($milieu, $s);
	if ((!$p) && (substr($milieu, 0, strlen($s)) != $s)) die("<h2>BOUCLE$id_boucle: tag fermant manquant</h2>");

	$fin = substr($milieu, $p + strlen($s));
	$milieu = substr($milieu, 0, $p);

	$s = "</B$id_boucle>";
	$p = strpos($fin, $s);
	if ($p || (substr($fin, 0, strlen($s)) == $s)) {
		$cond_fin = substr($fin, 0, $p);
		$fin = substr($fin, $p + strlen($s));
	}

	$s = "<//B$id_boucle>";
	$p = strpos($fin, $s);
	if ($p || (substr($fin, 0, strlen($s)) == $s)) {
		$cond_altern = substr($fin, 0, $p);
		$fin = substr($fin, $p + strlen($s));
	}

	$result->commande = $commande;
	$result->avant = $debut;
	$result->apres = $fin;
	$result->id_boucle = ereg_replace("-","_",$id_boucle);

	// Dterminer le type de la boucle

	$type = strtolower($nom);
	if (substr($type, 0, 6) == 'boucle') {
	  // Rcursion: pas de paramtre, donc presque rien  faire  
	  $result->type_requete = 'boucle';
	  $result->param = substr($nom, 6);
	} else {
	  if ($type == 'sites') $type = 'syndication';
	  $result->type_requete = $type;
	  parser_param($params, &$result, $id_boucle);
	}
	$result->cond_avant = parser($cond_avant, $id_parent);
	$result->cond_apres = parser($cond_fin, $id_parent);
	$result->cond_altern = parser($cond_altern, $id_parent);
	$result->milieu = parser($milieu, $id_boucle);
	
	return $result;
}

function parser($texte, $id_boucle) {
	global $boucles;

	
	while ($texte) {
	  if (!$boucle = parser_boucle($texte, $id_boucle)) {
	    $result = array_merge($result, parser_champs_etendus($texte));
	    $texte = '';
	  } else {
	    $result = array_merge($result, parser_champs_etendus($boucle->avant));
	    $texte = $boucle->apres;
	    $boucle->avant = '';
	    $boucle->apres = '';
	    $result[] = $boucle;
	    if (!$boucles[$boucle->id_boucle])
	      $boucles[$boucle->id_boucle] = $boucle;
	    else die ('<h2>BOUCLE'.$boucle->id_boucle.': double definition</h2>');
		}
	}

	return $result;
}
?>
